#include "character.h"
#include "main.h"
#include "misc.h"
#include <stdio.h>

struct scm_thing processcharacter(char** characters) {
    assert((*characters)[0] == '#' && (*characters)[1] == '\\');

    struct scm_thing character;
    character.type = NONE;

    if (charisdelimiter((*characters)[3])) {
        if ((*characters)[2] == ' ') {
            /* printf("character: #\\space\n"); */
        }
        else if ((*characters)[2] == '\n') {
            /* printf("character: #\\newline\n"); */
        }
        else {
            /* printf("character: #\\%c\n", (*characters)[2]); */
        }
        character.type = CHARACTER;
        character.character = (*characters)[2];
        (*characters) += 3;
    } else if ((*characters)[2] == 's' &&
	       (*characters)[3] == 'p' &&
	       (*characters)[4] == 'a' &&
	       (*characters)[5] == 'c' &&
	       (*characters)[6] == 'e' &&
	       charisdelimiter((*characters)[7])) {
        /* printf("character: #\\space\n"); */
        character.type = CHARACTER;
        character.character = ' ';
        (*characters) += 7;
    } else if ((*characters)[2] == 'n' &&
	       (*characters)[3] == 'e' &&
	       (*characters)[4] == 'w' &&
	       (*characters)[5] == 'l' &&
	       (*characters)[6] == 'i' &&
	       (*characters)[7] == 'n' &&
	       (*characters)[8] == 'e' &&
	       charisdelimiter((*characters)[9])) {
        /* printf("character: #\\newline\n"); */
        character.type = CHARACTER;
        character.character = '\n';
        (*characters) += 9;
    }
    return character;
}
