#pragma once

#include "main.h"

extern struct scm_thing * null_variables;
extern struct scm_thing * interactive_variables;

struct scm_thing * create_library_variables(struct scm_thing * (**procedures)(struct scm_thing *),
					    const char ** procedure_names,
					    uint32_t procudure_count,
					    struct scm_thing * (**macros)(struct scm_thing *,
									  struct scm_thing *,
									  struct scm_thing *),
					    const char ** macro_names,
					    uint32_t macro_count,
					    struct scm_thing * variables);

void create_null_variables(void);
void create_interactive_variables(void);
