#pragma once

#include "main.h"

struct scm_thing * transcribe_syntax_template(struct scm_thing * template,
					      struct scm_thing * matches,
					      struct scm_thing ** sterile,
					      struct scm_thing * top_level_environment);

bool test_pattern(struct scm_thing * pattern,
		  struct scm_thing * literals,
		  struct scm_thing * form,
		  struct scm_thing * local_environment,
		  struct scm_thing * top_level_environment);

struct scm_thing * match_pattern(struct scm_thing * pattern,
				 struct scm_thing * literals,
				 struct scm_thing * form,
				 struct scm_thing * result_head);

struct scm_thing * scm_syntax_rules(struct scm_thing * args,
				    struct scm_thing * local_environment,
				    struct scm_thing * top_level_environment);

void free_alist_structure(struct scm_thing * alist);
