(define (identity x) x)

(define (list->string list)
  (let ((string (make-string (length list))))
    (letrec ((internal-loop
	      (lambda (i list)
		(if (null? list)
		    string
		    (begin (string-set! string i (car list))
			   (internal-loop (+ i 1) (cdr list)))))))
      (internal-loop 0 list))))

(define (reverse list)
  (letrec ((internal-loop
	    (lambda (list new-list)
	      (if (null? list)
		  new-list
		  (internal-loop (cdr list)
				 (cons (car list) new-list))))))
    (internal-loop list '())))
